/*--------------------------------------------------------------------------------------------------------*\
|*                                                                                                        *|
|*                                      - NXT Smooth Tank Drive -                                         *|
|*                                            ROBOTC on NXT                                               *|
|*                                                                                                        *|
|*  This program allows you to drive a robot via remote control using the ROBOTC Debugger.                *|
|*  This particular method uses "Tank Drive" where each side is controlled individually like a tank.      *|
|*  This program also ignores low values that would cause your robot to move when the joysticks fail to   *|
|*  return back to exact center.  You may need to play with the 'threshold' value to get it just right.   *|
|*                                                                                                        *|
|*                                        ROBOT CONFIGURATION                                             *|
|*    NOTES:                                                                                              *|
|*                                                                                                        *|
|*    MOTORS & SENSORS:                                                                                   *|
|*    [I/O Port]              [Name]              [Type]              [Description]                       *|
|*    Port B                  motorB              NXT                 Right motor                         *|
|*    Port C                  motorC              NXT                 Left motor                          *|
\*---------------------------------------------------------------------------------------------------4246-*/

#include "JoystickDriver.c"
#pragma DebuggerWindows("joystickSimple")

task main()

{
	int threshold = 5;             /* Int 'threshold' will allow us to ignore low       */
	/* readings that keep our robot in perpetual motion. */

	repeat(forever)                            // Infinite loop:
	{
		getJoystickSettings(joystick);
		if(((abs(joystick.joy1_y1) > threshold)||(abs(joystick.joy1_y2) > threshold))&&(joy1Btn(6)==1))   // If the right analog stick's Y-axis readings are either above or below the threshold:
		{
			motor[motorB] = 50*(joystick.joy1_y1+0.5*joystick.joy1_y2)/192;
			motor[motorC] = 50*(joystick.joy1_y1-0.5*joystick.joy1_y2)/192;// Motor B is assigned a power level equal to the right analog stick's Y-axis reading.
		}
		else                                    // Else if the readings are within the threshold:
		{
		if((abs(joystick.joy1_y1) > threshold)||(abs(joystick.joy1_y2) > threshold))   // If the right analog stick's Y-axis readings are either above or below the threshold:
		{
			motor[motorB] = 100*(joystick.joy1_y1+0.5*joystick.joy1_y2)/192;
			motor[motorC] = 100*(joystick.joy1_y1-0.5*joystick.joy1_y2)/192;// Motor B is assigned a power level equal to the right analog stick's Y-axis reading.
		}
		else                                    // Else if the readings are within the threshold:
		{
			motor[motorB] = 0;
			motor[motorC] = 0;  // Motor B is stopped with a power level of 0.
		} // Motor B is stopped with a power level of 0.
		}


		if (joy1Btn(1)==1)
		{
			motor[motorA] = -100;
		}
		if (joy1Btn(3)==1)
		{
			motor[motorA] = 100;
		}

		if (joy1Btn(1)==0&&joy1Btn(3)==0)
		{
			motor[motorA] = 0;
		}

		if (joy1Btn(5)==0)
		{
			SensorType[S1]=sensorLightInactive;
		}
		if (joy1Btn(5)==1)
		{
			SensorType[S1]=sensorCustom9V;
		}

	}

}
